Page MenuHomePhabricator

[OpenMP] [DOCS] Update OMP5.0 feature status table [NFC]
ClosedPublic

Authored by kkwli0 on Jan 16 2020, 11:55 PM.

Diff Detail

Event Timeline

kkwli0 created this revision.Jan 16 2020, 11:55 PM
ABataev added inline comments.Jan 17 2020, 12:44 AM
clang/docs/OpenMPSupport.rst
194

We have support only for unified memory, so must be partial

210

I assume, it is done.

216

Is this for Fortran?

240

What is this?

242

What kind of memory model update?

jdoerfert added inline comments.Jan 17 2020, 10:59 AM
clang/docs/OpenMPSupport.rst
194

Let's keep the explicit (unified shared memory) -> done line and add one for the others as not done.

kkwli0 marked 2 inline comments as done.Jan 17 2020, 1:04 PM
kkwli0 added inline comments.
clang/docs/OpenMPSupport.rst
240

This is a clarification. The spec add restrictions to declare new type on iterators, declare reduction and declare mapper [49:11; 308:17; 327:26]

ABataev added inline comments.Jan 17 2020, 1:20 PM
clang/docs/OpenMPSupport.rst
240

Would be good to put these links to the doc to make it clear

kkwli0 marked an inline comment as done.Jan 17 2020, 1:20 PM
kkwli0 added inline comments.
clang/docs/OpenMPSupport.rst
194

@ABataev It makes sense to make it partial.

@jdoerfert Keeping that line can be confusing. Line 196 is clear to indicate that the unified_address and unified_shared_memory parts of the requires directive is done.

kkwli0 marked 2 inline comments as done.Jan 17 2020, 1:29 PM
kkwli0 added inline comments.
clang/docs/OpenMPSupport.rst
242

We add five _memory-order-clause_s in the atomic directive - seq_cst, acq_rel, release, acquire and relaxed to support the memory model.

ABataev added inline comments.Jan 17 2020, 1:40 PM
clang/docs/OpenMPSupport.rst
242

I would add as much as possible info about expected features to the doc, if possible

@kkwli0 I propose you can merge the parts where discussion has reached a consensus while the other parts are resolved. I'm generally fine with this, we can always improve on it further.

clang/docs/OpenMPSupport.rst
194

Fair point. thx.

216

No also C/C++.

240

Would be good to put these links to the doc to make it clear

Agreed. We have the HTML version of the standard online so we can do this "easily" but it will cost someone time and require to change the table layout. Let's postpone it for now until someone find some spare minutes.

242

I guess if they are unclaimed or done we can just list them in the description:

`memory model update (seq_cst, acq_rel, ...)`

and if we ever support a subset only we can make new rows for them.

dreachem added inline comments.Jan 22 2020, 12:35 PM
clang/docs/OpenMPSupport.rst
210

I think the description here should be something like "support close modifier on map clause". There is no "local" option for the map clause, and also the use of "close" is not dependent on the specification of the unified_shared_memory requirement.

kkwli0 marked 13 inline comments as done.Jan 22 2020, 3:07 PM
kkwli0 added inline comments.
clang/docs/OpenMPSupport.rst
216

Yep, it is not Fortran only. We clarify some pointer attachment behavior in 5.0.

240

Yes, it involves a significant change in the table if we include the corresponding text change in the table. In some cases, it is not clear from the original tickets. I think it is better to leave it as-is. If change the description can help, I welcome any suggestions.

kkwli0 updated this revision to Diff 239719.Jan 22 2020, 3:23 PM
kkwli0 marked 2 inline comments as done.

Address review comments and rebase.

ABataev added inline comments.Feb 3 2020, 8:20 AM
clang/docs/OpenMPSupport.rst
194

As far as I understand we only support parsing/sema for unified_address.

216

Could add a reference to the section in the standard?

238

Could you add a reference to the standard?

kkwli0 updated this revision to Diff 242166.Feb 3 2020, 1:19 PM

Change requires unified_address status to partial.

kkwli0 marked 2 inline comments as done.Feb 3 2020, 1:23 PM
kkwli0 added inline comments.
clang/docs/OpenMPSupport.rst
216

I am not sure if this and another feature should be treated as special cases. If it is not, we will need to add references for all the features.

ABataev accepted this revision.Feb 3 2020, 1:27 PM

LG, but still would be good to add some references to the standard. Some of the features use special wording, which very hard to find in the standard.

This revision is now accepted and ready to land.Feb 3 2020, 1:27 PM
This revision was automatically updated to reflect the committed changes.
Herald added a project: Restricted Project. · View Herald TranscriptFeb 3 2020, 3:34 PM